// util.cpp - 'A Quest Too Far'
//
// Copyright 2010 Geoffrey White
//
// see readme.txt for more details.

#include "util.h"

// --- translate_direction_key ---

struct key_move
{
	SDLKey key;
	int delta_x, delta_y;
};
key_move key_moves[] =
{{SDLK_UP,		0,	-1},
 {SDLK_KP8,		0,	-1},
 {SDLK_DOWN,	0,	1},
 {SDLK_KP2,		0,	1},
 {SDLK_LEFT,	-1,	0},
 {SDLK_KP4,		-1,	0},
 {SDLK_RIGHT,	1,	0},
 {SDLK_KP6,		1,	0},
 {SDLK_HOME,	-1,	-1},
 {SDLK_KP7,		-1,	-1},
 {SDLK_PAGEUP,	1,	-1},
 {SDLK_KP9,		1,	-1},
 {SDLK_END,		-1,	1},
 {SDLK_KP1,		-1,	1},
 {SDLK_PAGEDOWN,1,	1},
 {SDLK_KP3,		1,	1}};

bool translate_direction_key(const char_key &key, int &out_dx, int &out_dy)
{
	int i;

	for (i = 0; i < sizeof(key_moves) / sizeof(key_move); i++)
	{
		if (key.sdl == key_moves[i].key)
		{
			out_dx = key_moves[i].delta_x;
			out_dy = key_moves[i].delta_y;
			return true;
		}
	}

	return false;
}